///////////////////////// SD ////////////////////////////////////////////



String getSubstring(String dataString, char separator, int index)
{
    int found = 0;
    int strIndex[] = { 0, -1 };
    int maxIndex = dataString.length() - 1;

    for (int i = 0; i <= maxIndex && found <= index; i++) {
        if (dataString.charAt(i) == separator || i == maxIndex) {
            found++;
            strIndex[0] = strIndex[1] + 1;
            strIndex[1] = (i == maxIndex) ? i+1 : i;
        }
    }
    return found > index ? dataString.substring(strIndex[0], strIndex[1]) : "";
}



bool readSDconfig(){
  File configFile = SD.open("config.txt");
  while (configFile.available()) {                  //as long as there is data available
    String buf = configFile.readStringUntil('\n');  // read a line
    String keyword = getSubstring(buf, ' ', 0);     // update variable according to keyword
    if (keyword == "LOW") { dimmer_low = getSubstring(buf, ' ', 1).toInt() ; }
    if (keyword == "HIGH") { dimmer_high = getSubstring(buf, ' ', 1).toInt() ; }
    if (keyword == "MID") { dimmer_mid = getSubstring(buf, ' ', 1).toInt() ; }
    
    if (keyword == "MER") { fill_solid( palette_MER, 16, CRGB(getSubstring(buf, ' ', 1).toInt(), getSubstring(buf, ' ', 2).toInt(), getSubstring(buf, ' ', 3).toInt()) ) ; }
    if (keyword == "SOLEIL") { fill_solid( palette_SOLEIL, 16, CRGB(getSubstring(buf, ' ', 1).toInt(), getSubstring(buf, ' ', 2).toInt(), getSubstring(buf, ' ', 3).toInt()) ) ; }
    if (keyword == "CREPUSCULE") { fill_solid( palette_CREPUSCULE, 16, CRGB(getSubstring(buf, ' ', 1).toInt(), getSubstring(buf, ' ', 2).toInt(), getSubstring(buf, ' ', 3).toInt()) ) ; }
    if (keyword == "FLAMINGO") { fill_solid( palette_FLAMINGO, 16, CRGB(getSubstring(buf, ' ', 1).toInt(), getSubstring(buf, ' ', 2).toInt(), getSubstring(buf, ' ', 3).toInt()) ) ; }
  }
  
  Serial.println("Configuration : ");
  Serial.print("Niveaux dimmer (LOW / MID / HIGH) : ");
  Serial.print(dimmer_low);
  Serial.print(" ");
  Serial.print(dimmer_mid);
  Serial.print(" ");
  Serial.print(dimmer_high);
  Serial.println("");
  Serial.print("Palette MER : ");
  Serial.print(ColorFromPalette(palette_MER, 0));
  Serial.print("Palette SOLEIL : ");
  Serial.print(ColorFromPalette(palette_SOLEIL, 0));
  Serial.print("Palette CREPUSCULE : ");
  Serial.print(ColorFromPalette(palette_CREPUSCULE, 0));
  Serial.print("Palette FLAMINGO : ");
  Serial.print(ColorFromPalette(palette_FLAMINGO, 0));
//  Serial.print(" ");
//  Serial.print(dimmer_mid);
//  Serial.print(" ");
//  Serial.print(dimmer_high);
  Serial.println("");
  configFile.close();  
}


bool readSDFile() {
  
  if (!inibSDreading) { // if currently delaying, don't read a line 
    if (btnFile.available()) {
      buf = btnFile.readStringUntil('\n');
      
      //check selector (1st word of line) and execute corresponding function
      String selector = getSubstring(buf, ' ', 0);
      //Serial.println(selector);
      
      if (selector == "sound") {
        String track = getSubstring(buf, ' ', 2) ;
        String out = getSubstring(buf, ' ', 1) ;
        Serial.println("Playing track " + track + " to output " + out);
        tsunami.trackPlayPoly(track.toInt(), out.toInt()-1, true);     
      }
      
      else if (selector == "led") {
        Serial.println("led");
//        String mode = getSubstring(buf, ' ', 1);
//        if (mode == "L"){ 
//          int R = getSubstring(buf, ' ', 2).toInt();
//          int G = getSubstring(buf, ' ', 3).toInt();
//          int B = getSubstring(buf, ' ', 4).toInt();
//          for (int i ; i<NUM_LEDS_LUSTRE ; i++) {
//            lustreLeds[i].setRGB(R, G, B) ;
//          }         
//        }
//        if (mode == "T"){ 
//          int R = getSubstring(buf, ' ', 2).toInt();
//          int G = getSubstring(buf, ' ', 3).toInt();
//          int B = getSubstring(buf, ' ', 4).toInt();
//          for (int i ; i<NUM_LEDS_TABLE ; i++) {
//            tableLeds[i].setRGB(R, G, B) ;
//          }         
//        }
//        Serial.println("Led mode " + getSubstring(buf, ' ', 1));
      }
     
      else if (selector == "dimmer") {
        String dim_val = getSubstring(buf, ' ', 1);
        int dimmer_value;
        int dimmer_fade = getSubstring(buf, ' ', 2).toInt();
        Serial.println("Dimmer fade à " + dim_val + " en " + dimmer_fade + "ms");
        if (dim_val == "LOW") {dimmer_value = dimmer_low ;}
        else if (dim_val == "MID") {dimmer_value = dimmer_mid ;}
        else if (dim_val == "HIGH") {dimmer_value = dimmer_high ;}
        else if (dim_val == "OFF") {dimmer_value = 0 ;}
        else { dimmer_value = dim_val.toInt();} //value% 
        dimmer.setTime(dimmer_fade);
        dimmer.set(percent2PWM(dimmer_value));
//      Serial.println(dimmer_delta);
        
      }
      
      else if (selector == "delay") {
        String wait = getSubstring(buf, ' ', 1);
        Serial.println("delai " + wait + " ms");
        inibSDreading = true ;
        delay_start = millis();
        delay_length = wait.toInt() ;
//        delay_flag = 0 ;
        mgr.addListener(new EvtTimeListener(50 , true, (EvtAction)checkDelay));
          
        //delay(wait.toInt());
      }
  
      else if (selector == ""){}
     
      else {
        Serial.print(selector);
        Serial.println(": pas compris");
        }
      
      
    }
    
    else {
      Serial.println("EOF");
      inibSDreading = true;
//      btnFile.close();
      EvtResetButtonContext();
      
      
    }
  }
//  else{
//    Serial.println("not reading");
//    }
  return false ;
  
}
